#ifndef PGM2ASC_H
#define PGM2ASC_H 1

#include "pnm.h"

#define Uint  unsigned int
#define Uchar unsigned char


extern "C"{

   /* start ocr on a image in pix */
   int pgm2asc(
	       pix *pp,			// see pnm.h, pixelbuffer and size
	       int mo, int cs, int spc,	// mode=0 cs=0 spacewidth=0
	       int dust_size, char *lc,	// dust_size=10 listchars="_"
	       int vvv			// verbose=0
	       );

   
   /* free memory for internal stored textlines.
    * Needs to be called _after_ having retrieved the text.
    * After freeing, no call to getTextLine is possible any
    * more
    */
   void free_textlines( void );

   /* get result of ocr for a given line number.
    * If the line is out of range, the function returns 0,
    * otherwise a pointer to a complete line.
    */
   const char *getTextLine( int );
   
} /* extern C */

#endif
